/// @cond EO_CXX_EO_IMPL

inline ::efl::eina::string_view elm::segment_control::item_label_get(int idx_) const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_label_get(idx_));
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::segment_control::item_insert_at(::evas::object icon_, ::efl::eina::optional< ::efl::eina::string_view > label_, int idx_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_insert_at(::efl::eolian::to_c(icon_), ::efl::eolian::to_c(label_), idx_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::segment_control::item_get(int idx_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_get(idx_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::segment_control::item_del_at(int idx_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_segment_control_item_del_at(idx_));
}

inline ::elm::widget_item elm::segment_control::item_add(::evas::object icon_, ::efl::eina::optional< ::efl::eina::string_view > label_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_add(::efl::eolian::to_c(icon_), ::efl::eolian::to_c(label_)));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object elm::segment_control::item_icon_get(int idx_) const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_icon_get(idx_));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline int elm::segment_control::item_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_count_get());
   return _tmp_ret;
}

inline ::elm::widget_item elm::segment_control::item_selected_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_selected_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::string_view eo_cxx::elm::segment_control::item_label_get(int idx_) const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_label_get(idx_));
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::segment_control::item_insert_at(::evas::object icon_, ::efl::eina::optional< ::efl::eina::string_view > label_, int idx_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_insert_at(::efl::eolian::to_c(icon_), ::efl::eolian::to_c(label_), idx_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::segment_control::item_get(int idx_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_get(idx_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::segment_control::item_del_at(int idx_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_segment_control_item_del_at(idx_));
}

inline ::elm::widget_item eo_cxx::elm::segment_control::item_add(::evas::object icon_, ::efl::eina::optional< ::efl::eina::string_view > label_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_add(::efl::eolian::to_c(icon_), ::efl::eolian::to_c(label_)));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object eo_cxx::elm::segment_control::item_icon_get(int idx_) const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_icon_get(idx_));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline int eo_cxx::elm::segment_control::item_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_count_get());
   return _tmp_ret;
}

inline ::elm::widget_item eo_cxx::elm::segment_control::item_selected_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_segment_control_item_selected_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::segment_control::operator ::elm::segment_control() const
{
   return *static_cast<::elm::segment_control const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::segment_control::operator ::elm::segment_control&()
{
   return *static_cast<::elm::segment_control*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::segment_control::operator ::elm::segment_control const&() const
{
   return *static_cast<::elm::segment_control const*>(static_cast<void const*>(this));
}

template <typename T>
::efl::eina::string_view elm_segment_control_item_label_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int idx_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_label_get(idx_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_segment_control_item_insert_at_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * icon_, const char * label_, int idx_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_at(::efl::eolian::to_cxx<::evas::object>(icon_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(label_, std::tuple<std::false_type>()), idx_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_segment_control_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int idx_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_get(idx_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_segment_control_item_del_at_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int idx_)
{
   try
      {
         static_cast<T*>(self->this_)->item_del_at(idx_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_segment_control_item_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * icon_, const char * label_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_add(::efl::eolian::to_cxx<::evas::object>(icon_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(label_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::evas::object elm_segment_control_item_icon_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int idx_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_icon_get(idx_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
int elm_segment_control_item_count_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->item_count_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
::elm::widget_item elm_segment_control_item_selected_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->item_selected_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::segment_control >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
   {
      virtual ::efl::eina::string_view item_label_get(int idx_)
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_segment_control_item_label_get(idx_));
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_insert_at(::evas::object icon_, ::efl::eina::optional< ::efl::eina::string_view > label_, int idx_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_segment_control_item_insert_at(::efl::eolian::to_c(icon_), ::efl::eolian::to_c(label_), idx_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_get(int idx_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_segment_control_item_get(idx_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void item_del_at(int idx_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_segment_control_item_del_at(idx_));
      }

      virtual ::elm::widget_item item_add(::evas::object icon_, ::efl::eina::optional< ::efl::eina::string_view > label_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_segment_control_item_add(::efl::eolian::to_c(icon_), ::efl::eolian::to_c(label_)));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::evas::object item_icon_get(int idx_)
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_segment_control_item_icon_get(idx_));
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual int item_count_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_segment_control_item_count_get());
            return _tmp_ret;
      }

      virtual ::elm::widget_item item_selected_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_segment_control_item_selected_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::segment_control >
{
   static constexpr int value = 
#if defined(SEGMENT_CONTROL_PROTECTED) && defined(SEGMENT_CONTROL_BETA)
      8
#elif defined(SEGMENT_CONTROL_PROTECTED)
      8
#elif defined(SEGMENT_CONTROL_BETA)
      8
#else
      8
#endif
      + operation_description_class_size<::elm::layout >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::segment_control>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_segment_control_item_label_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_segment_control_item_label_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_segment_control_item_insert_at_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_segment_control_item_insert_at);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_segment_control_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_segment_control_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_segment_control_item_del_at_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_segment_control_item_del_at);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_segment_control_item_add_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_segment_control_item_add);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_segment_control_item_icon_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_segment_control_item_icon_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_segment_control_item_count_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_segment_control_item_count_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_segment_control_item_selected_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_segment_control_item_selected_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::segment_control >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::segment_control>)
{
   return (ELM_SEGMENT_CONTROL_CLASS);
}

} } }

/// @endcond

